import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int k = nextInt(), n = nextInt();
        int[][] a = new int[10000][10000];
        int x = 5000, y = 5000;
        long ans = 0;
        for (int i = 0; i < n; i++) {
            char c = nextToken().charAt(0);
            int s = nextInt();
            if (c == 'S') {
                for (int j = x - k + 1; j <= x + s; j++) {
                    for (int l = y; l < y + k; l++) {
                        if (a[j][l] == 0) {
                            ans++;
                            a[j][l] = 1;
                        }
                    }
                }
                x += s;
            } else if (c == 'N') {
                for (int j = x - s - k + 1; j <= x; j++) {
                    for (int l = y; l < y + k; l++) {
                        if (a[j][l] == 0) {
                            ans++;
                            a[j][l] = 1;
                        }
                    }
                }
                x -= s;
            } else if (c == 'W') {
                for (int j = x - k + 1; j <= x; j++) {
                    for (int l = y - s; l < y + k; l++) {
                        if (a[j][l] == 0) {
                            ans++;
                            a[j][l] = 1;
                        }
                    }
                }
                y -= s;
            } else {
                for (int j = x - k + 1; j <= x; j++) {
                    for (int l = y; l < y + k + s; l++) {
                        if (a[j][l] == 0) {
                            ans++;
                            a[j][l] = 1;
                        }
                    }
                }
                y += s;
            }
        }
        out.println(ans);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}