import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long p = nextLong();
        long[] z = new long[n];
        long[] a = new long[n];
        long[] b = new long[n];
        for (int i = 0; i < n; i++) {
            z[i] = nextInt();
            a[i] = nextInt();
            b[i] = nextInt();
        }
        long l = 0, r = (long) 1e6;
        while (l + 1 < r) {
            long m = (l + r) / 2;
            long sum = 0;
            for (int i = 0; i < n; i++) {
                if (m > z[i]) {
                    sum += a[i] * z[i] + b[i] * (m - z[i]);
                } else {
                    sum += a[i] * m;
                }
            }
            if (sum < p) l = m;
            else r = m;
        }
        out.println(r);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}