import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    static long n, ans;

    public static void main(String[] args) throws IOException {
        n = nextInt();
        int m = nextInt();
        int[] a = new int[m];
        for (int i = 0; i < m; i++) {
            a[i] = nextInt();
        }
        ans = 0;
        long[] dp = new long[101];
        for (int i = 0; i <= n; i++) {
            if (i <= a[m - 1]) {
                dp[i] = 1;
            } else {
                dp[i] = (long) ((dp[i - a[m - 1] + 1] + dp[i - a[m - 1]]) % (1e9 + 7));
            }
            ans += dp[i];
            ans %= (1e9 + 7);
        }
        if(m == 1) out.println(1);
        else out.println(ans);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");

    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}