import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int t = nextInt();
        for (int q = 0; q < t; q++) {
            long a = nextLong(), b = nextLong(), k = nextLong(), m = nextLong();
            long l1 = Math.min(Math.max(0, k - b + 1), b - 1), r1 = Math.min(k / 2, b);
            while (l1 + 1 < r1) {
                long mid = (l1 + r1) / 2;
                if ((mid + 1) * (k - mid + 1) <= m) {
                    l1 = mid;
                } else {
                    r1 = mid;
                }
            }
            long l2 = Math.min(Math.max(k / 2, k - b + 1), b - 1), r2 = Math.min(k + 1, b);
            while (l2 + 1 < r2) {
                long mid = (l2 + r2) / 2;
                if ((mid + 1) * (k - mid + 1) < m) {
                    r2 = mid;
                } else {
                    l2 = mid;
                }
            }
            if (k - l2 < a && (l2 + 1) * (k - l2 + 1) == m) {
                out.println((k - l2) + " " + l2);
            } else if (k - l1 < a && (l1 + 1) * (k - l1 + 1) == m) {
                out.println((k - l1) + " " + l1);
            } else {
                out.println(-1);
            }
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}