import java.io.*;
import java.util.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int t = nextInt();
        for (int q = 0; q < t; q++) {
            long a = nextLong(), b = nextLong(), k = nextLong(), m = nextLong();
            boolean x = false;
            for (int i = 1; i <= Math.sqrt(m); i++) {
                if(m % i == 0){
                    long j = m / i;
                    if(i <= a && j <= b && i + j == k + 2){
                        x = true;
                        out.println((i - 1) + " " + (j - 1));
                        break;
                    }
                }
            }
            if(!x) out.println(-1);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}