import java.io.*;
import java.util.*;

public class Main {
    static long[] dp;
    static long ans;

    static void rec(long n, int j) {
        if(n == 1){
            ++ans;
            return;
        }
        for (int i = j; i < dp.length && dp[i] <= n; ++i) {
            if (n % dp[i] == 0) {
                rec(n / dp[i], i);
            }
        }
    }

    public static void main(String[] args) throws IOException {
        dp = new long[1000000];
        dp[0] = 1;
        dp[1] = 1;
        for (int i = 2; i < 1000000; ++i) {
            dp[i] = dp[i - 1] + dp[i - 2];
        }
        int t = nextInt();
        for (int q = 0; q < t; ++q) {
            long n = nextLong();
            ans = 0;
            rec(n, 2);
            out.println(ans);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}