import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int q = nextInt();
        long[] a = new long[n];
        long[][] ans = new long[n][n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        for (int i = 0; i < n; i++) {
            int l = i - 1, r = i + 1, step = 1;
            ans[i][0]++;
            while (l >= 0 || r < n) {
                if (l >= 0 && r < n && a[l] < a[r]) {
                    ans[l][step]++;
                    l--;
                } else if (r < n) {
                    ans[r][step]++;
                    r++;
                } else {
                    ans[l][step]++;
                    l--;
                }
                step++;
            }
        }
        for (int i = 0; i < q; i++) {
            out.println(ans[nextInt() - 1][nextInt() - 1]);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}