import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    static long n;
    static Deque<Character> ans = new LinkedList<>();
    static ArrayList<Long> invented = new ArrayList<>();

    static void rec(long i) {
        if (invented.contains(i)) return;
        invented.add(i);
        if (i == n) {
            while (!ans.isEmpty()) {
                out.print(ans.pollFirst());
            }
            out.close();
            System.exit(0);
        }
        ans.addLast('B');
        rec(i / 2);
        ans.pollLast();

        ans.addLast('A');
        rec(i * 3 + 1);
        ans.pollLast();
    }

    public static void main(String[] args) throws IOException {
        n = nextLong();
        rec(1);
        out.println(-1);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}