import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    static long n;
    public static void main(String[] args) throws IOException {
        n = nextLong();
        Stack<Character> ans = new Stack<>();
        while(n != 1){
            if((n - 1) % 3 == 0) {
                n = (n - 1) / 3;
                ans.push('A');
            }else if(n % 2 == 0){
                n = n * 2 + 1;
                ans.push('B');
            }else {
                n = n * 2;
                ans.push('B');
            }
        }
        while(!ans.isEmpty()){
            out.print(ans.pop());
        }
        out.close();
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");

    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }
    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}